.486
.model flat, stdcall
option casemap:none

include menuitems.inc

.code

displayCategoryDialog proc hWnd:HWND
	.data
	catDlg db "This dialog is not yet implemented",0
	information db "Information",0
	
	.code
			invoke MessageBox,hWnd,addr catDlg, addr information, MB_OK OR MB_ICONINFORMATION
		ret

displayCategoryDialog ENDP

displayLicenseMsg proc hWnd:HWND
	
	.data
	msgstr db "Copyright ",169," 2004 Programmers' Haven, all rights reserved.",0
	msgtitle db "License Information",0
	
	.code
	invoke MessageBox,hWnd,addr msgstr,addr msgtitle,\
	MB_OK OR MB_ICONINFORMATION
	ret

displayLicenseMsg endp


showGpl proc hWnd:HWND
	
invoke DialogBoxParam,hInstance,IDD_GPL,hWnd,addr gplProc,0
	ret

showGpl endp


gplProc proc hWnd:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM
	
	LOCAL gpltxt:DWORD
	LOCAL fp:HANDLE
	LOCAL pMemory:DWORD
	LOCAL hMapped:HANDLE
	LOCAL fileSize:DWORD
	LOCAL numBytesRead:DWORD
		
	.data
	fileName db "./copying",0
	align 4
	
	fileOpenFailure db "Could not find the license file!",0
	align 4
	
	fileOpenFailureTitle db "Error",0
	align 4
	
	
	fileMappingFailure db "Could not map the license file",0
	align 4
	
	fileMappingFailureTitle db "Failure mapping error",0
	align 4
	
	fileViewFailure db "Failed mapping the view of the license file",0
	align 4
	
	fileViewFailureTitle db "File view mapping failure",0
	align 4
	
	
	.code
	mov eax, msg
	
	cmp eax, WM_CLOSE
	jne notClose
			invoke EndDialog,hWnd,0
	jmp endMsgCompare
	
		notClose:
	
	cmp eax, WM_INITDIALOG
	jne notInitDialog
	
invoke CreateFile,addr fileName,GENERIC_READ,\
FILE_SHARE_READ OR FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
mov fp,eax

cmp eax, INVALID_HANDLE_VALUE
jne isValidOpen
invoke MessageBox,hWnd,addr fileOpenFailure,addr fileOpenFailureTitle,MB_OK OR MB_ICONEXCLAMATION
invoke EndDialog, hWnd, 0
ret  

isValidOpen:	

invoke CreateFileMapping,fp,NULL,PAGE_READONLY,0,0,NULL
mov hMapped,eax

test eax, eax
jnz isValidMapping
invoke MessageBox,hWnd,addr fileMappingFailure,addr fileMappingFailureTitle,MB_OK OR MB_ICONEXCLAMATION
invoke EndDialog,hWnd,0
ret
isValidMapping:	
		
	invoke MapViewOfFile,hMapped,FILE_MAP_READ,0,0,0
	mov pMemory,eax
	
	test eax, eax
	jnz isValidView
	invoke MessageBox,hWnd,addr fileViewFailure,addr fileViewFailureTitle,MB_OK OR MB_ICONEXCLAMATION
	invoke EndDialog,hWnd,0 
	ret
	
	isValidView:

invoke GetFileSize,fp,NULL
mov fileSize,eax

invoke ReadFile,fp,pMemory,fileSize,addr numBytesRead,NULL

invoke SetDlgItemText,hWnd,IDD_LICENSE,pMemory
	
	invoke UnmapViewOfFile,pMemory
	invoke CloseHandle,hMapped
	invoke CloseHandle,fp

invoke SendDlgItemMessage,hWnd,IDD_LICENSE,WM_KILLFOCUS,hWnd,0
invoke SetFocus,hWnd


jmp endMsgCompare
	
		notInitDialog:
	
	cmp eax,WM_COMMAND
	jne notCommand
	mov eax, wParam
	
	cmp ax, IDOK
	jne notOK
	invoke SendMessage,hWnd,WM_CLOSE,0,0
	jmp endMsgCompare
	
	notOK:
	
	jmp endMsgCompare
	
	notCommand:
	
	mov eax,FALSE
	ret
	
	endMsgCompare:
	
	mov eax, TRUE
	
		ret

gplProc endp

end